package virtbuf

// functions to import and export the protobuf
// data to and from config files

import (
	"fmt"
	"os"
	"path/filepath"

	"google.golang.org/protobuf/encoding/protojson"
	"google.golang.org/protobuf/encoding/prototext"
	"google.golang.org/protobuf/reflect/protoreflect"
)

// save the events config file in both json and prototext
func (e *Events) ConfigSave() error {
	if err := ConfigWriteJSON(e, "events.json"); err != nil {
		return err
	}

	return ConfigWriteTEXT(e, "events.text")
}

// read in the events log file
// reads in from the prototext file
// prototext file formats are not garrenteed to be stable. todo: hammer that out
func (e *Events) ConfigRead() error {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "events.text")
	data, err := os.ReadFile(fullname)
	if err != nil {
		return err
	}
	return prototext.Unmarshal(data, e)
}

// get the list of droplets from the config file
func (d *Droplets) ConfigRead() error {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "droplets.json")
	data, err := os.ReadFile(fullname)
	if err != nil {
		return err
	}
	return protojson.Unmarshal(data, d)
	/*
		err = d.UnmarshalJSON(data)
		if err != nil {
			return err
		}
		return nil
	*/
}

//func (e *Events) ConfigSave() error {
//	return ConfigWriteJSON(e, "events.json")
//}

// save the droplet settings in a config file
// uses 'protojson.Format' which is more or less human readable
func (d *Droplets) ConfigSave() error {
	return ConfigWriteJSON(d, "droplets.json")
	/*
		fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "droplets.json")
		cfgfile, err := os.OpenFile(fullname, os.O_RDWR|os.O_CREATE, 0666)
		defer cfgfile.Close()
		if err != nil {
			fmt.Println("open config file :", err)
			return err
		}
		text := protojson.Format(d)
		fmt.Fprintln(cfgfile, text)
		return nil
	*/
}

func ConfigWriteJSON(a any, filename string) error {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), filename)
	cfgfile, err := os.OpenFile(fullname, os.O_RDWR|os.O_CREATE, 0666)
	defer cfgfile.Close()
	if err != nil {
		fmt.Println("open config file :", err)
		return err
	}
	msg, ok := a.(protoreflect.ProtoMessage)
	if !ok {
		return fmt.Errorf("provided value does not implement protoreflect.ProtoMessage")
	}
	text := protojson.Format(msg)
	fmt.Fprintln(cfgfile, text)
	return nil
}

func ConfigWriteTEXT(a any, filename string) error {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), filename)
	cfgfile, err := os.OpenFile(fullname, os.O_RDWR|os.O_CREATE, 0666)
	defer cfgfile.Close()
	if err != nil {
		fmt.Println("open config file :", err)
		return err
	}
	msg, ok := a.(protoreflect.ProtoMessage)
	if !ok {
		return fmt.Errorf("provided value does not implement protoreflect.ProtoMessage")
	}
	text := prototext.Format(msg)
	fmt.Fprintln(cfgfile, text)
	return nil
}

func WriteConfig(d *Droplets, h *Hypervisors, e *Events) bool {
	if !d.WriteConfigJSON() {
		return false
	}
	if !d.WriteConfigTEXT() {
		return false
	}

	if err := e.WriteConfigJSON(); err != nil {
		return false
	}
	if err := e.WriteConfigTEXT(); err != nil {
		return false
	}
	return true
}

// read in events.json
func ReadEventsConfig() (*Events, error) {
	e := new(Events)
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "events.json")
	data, err := os.ReadFile(fullname)
	if err != nil {
		// log.Info("open config file :", err)
		return nil, err
	}
	err = e.UnmarshalJSON(data)
	if err != nil {
		// log.Info("read json failed", err)
		return nil, err
	}

	return e, nil
}

// export as json
func (e *Events) WriteConfigJSON() error {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "events.json")
	cfgfile, err := os.OpenFile(fullname, os.O_RDWR|os.O_CREATE, 0666)
	defer cfgfile.Close()
	if err != nil {
		fmt.Println("open config file :", err)
		return err
	}
	text := e.FormatJSON()
	fmt.Fprintln(cfgfile, text)
	fmt.Println("Write:", fullname, "OK")
	return nil
}

// export as prototext
func (e *Events) WriteConfigTEXT() error {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "events.text")
	cfgfile, err := os.OpenFile(fullname, os.O_RDWR|os.O_CREATE, 0666)
	defer cfgfile.Close()
	if err != nil {
		fmt.Println("open config file :", err)
		return err
	}
	text := e.FormatTEXT()
	fmt.Fprintln(cfgfile, text)
	fmt.Println("Write:", fullname, "OK")
	return nil
}

// export as json
func (d *Droplets) WriteConfigJSON() bool {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "droplets.json")
	cfgfile, err := os.OpenFile(fullname, os.O_RDWR|os.O_CREATE, 0666)
	defer cfgfile.Close()
	if err != nil {
		fmt.Println("open config file :", err)
		return false
	}
	text := d.FormatJSON()
	fmt.Fprintln(cfgfile, text)
	fmt.Println("Write:", fullname, "OK")
	return true
}

// export as prototext
func (d *Droplets) WriteConfigTEXT() bool {
	fullname := filepath.Join(os.Getenv("VIRTIGO_HOME"), "droplets.text")
	cfgfile, err := os.OpenFile(fullname, os.O_RDWR|os.O_CREATE, 0666)
	defer cfgfile.Close()
	if err != nil {
		fmt.Println("open config file :", err)
		return false
	}
	text := d.FormatTEXT()
	fmt.Fprintln(cfgfile, text)
	fmt.Println("Write:", fullname, "OK")
	return true
}

// human readable JSON
func (c *Cluster) FormatJSON() string {
	return protojson.Format(c)
}

func (d *Droplets) FormatJSON() string {
	return protojson.Format(d)
}

func (e *Events) FormatJSON() string {
	return protojson.Format(e)
}

// apparently this isn't supposed to be used?
// https://protobuf.dev/reference/go/faq/#unstable-text
// this is a shame because this is much nicer output than JSON Format()
func (c *Cluster) FormatTEXT() string {
	return prototext.Format(c)
}

func (d *Droplets) FormatTEXT() string {
	return prototext.Format(d)
}

func (e *Events) FormatTEXT() string {
	return prototext.Format(e)
}

// marshal
func (c *Cluster) MarshalJSON() ([]byte, error) {
	return protojson.Marshal(c)
}

func (d *Droplets) MarshalJSON() ([]byte, error) {
	return protojson.Marshal(d)
}

func (e *Events) MarshalJSON() ([]byte, error) {
	return protojson.Marshal(e)
}

// unmarshal
func (c *Cluster) UnmarshalJSON(data []byte) error {
	return protojson.Unmarshal(data, c)
}

func (d *Droplets) UnmarshalJSON(data []byte) error {
	return protojson.Unmarshal(data, d)
}

func (e *Events) UnmarshalJSON(data []byte) error {
	return protojson.Unmarshal(data, e)
}
